<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑' : '添加'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="用户ID" name="adminId">
        <a-input
          allow-clear
          placeholder="请输入用户ID"
          v-model:value="form.adminId"
        />
      </a-form-item>
      <a-form-item label="用户姓名" name="adminName">
        <a-input
          allow-clear
          placeholder="请输入用户姓名"
          v-model:value="form.adminName"
        />
      </a-form-item>
      <a-form-item label="描述" name="description">
        <a-input
          allow-clear
          placeholder="请输入描述"
          v-model:value="form.description"
        />
      </a-form-item>
      <a-form-item label="IP地址" name="ip">
        <a-input
          allow-clear
          placeholder="请输入IP地址"
          v-model:value="form.ip"
        />
      </a-form-item>
      <a-form-item label="1 成功 2 失败" name="status">
        <a-radio-group v-model:value="form.status">
          <a-radio :value="0">显示</a-radio>
          <a-radio :value="1">隐藏</a-radio>
        </a-radio-group>
      </a-form-item>
      <a-form-item label="添加时间" name="addTime">
        <a-input
          allow-clear
          placeholder="请输入添加时间"
          v-model:value="form.addTime"
        />
      </a-form-item>
      <a-form-item label="0:操作日志;1:登录日志;2:定时任务 " name="logType">
        <a-input
          allow-clear
          placeholder="请输入0:操作日志;1:登录日志;2:定时任务 "
          v-model:value="form.logType"
        />
      </a-form-item>
      <a-form-item label="事务类型 0查询，2添加，4修改，8删除  16 导入 32 导出   当方法中存在 多种类型时候使用 或（|）操作 " name="operateType">
        <a-input
          allow-clear
          placeholder="请输入事务类型 0查询，2添加，4修改，8删除  16 导入 32 导出   当方法中存在 多种类型时候使用 或（|）操作 "
          v-model:value="form.operateType"
        />
      </a-form-item>
      <a-form-item label="执行事务的方法名称 " name="method">
        <a-input
          allow-clear
          placeholder="请输入执行事务的方法名称 "
          v-model:value="form.method"
        />
      </a-form-item>
      <a-form-item label="执行事务的方法的参数 " name="params">
        <a-input
          allow-clear
          placeholder="请输入执行事务的方法的参数 "
          v-model:value="form.params"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addThinkLog, updateThinkLog } from '@/api/think/thinkLog';
  import { ThinkLog } from '@/api/think/thinkLog/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ThinkLog | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ThinkLog>({
    logId: undefined,
    adminId: undefined,
    adminName: undefined,
    description: undefined,
    ip: undefined,
    status: undefined,
    addTime: undefined,
    logType: undefined,
    operateType: undefined,
    method: undefined,
    params: undefined,
    thinkLogId: undefined,
    thinkLogName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    thinkLogName: [
      {
        required: true,
        type: 'string',
        message: '请填写名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateThinkLog : addThinkLog;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
